//
//  GCPing.h
//  GCPing
//
//  Created by Luka Mirosevic on 05/11/2012.
//  Copyright (c) 2012 Goonbee. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "GamePingSummary.h"

@class GamePingSummary;
@protocol GCPingDelegate;

NS_ASSUME_NONNULL_BEGIN

typedef void(^StartupCallback)(BOOL success, NSError * _Nullable error);

@interface GamePing : NSObject

@property (weak, nonatomic, nullable) id<GCPingDelegate>      delegate;

@property (copy, nonatomic, nullable) NSString                *host;
@property (assign, atomic) NSTimeInterval           pingPeriod;
@property (assign, atomic) NSTimeInterval           timeout;
@property (assign, atomic) NSUInteger               payloadSize;
@property (assign, atomic) NSUInteger               ttl;
@property (assign, atomic, readonly) BOOL           isPinging;
@property (assign, atomic, readonly) BOOL           isReady;

@property (assign, atomic) BOOL                     debug;

-(void)setupWithBlock:(StartupCallback)callback;
-(void)startPinging;
-(void)stop;

@end

@protocol GCPingDelegate <NSObject>

@optional

-(void)ping:(GamePing *)pinger didFailWithError:(NSError *)error;
-(void)ping:(GamePing *)pinger didSendPingWithSummary:(GamePingSummary *)summary;
-(void)ping:(GamePing *)pinger didFailToSendPingWithSummary:(GamePingSummary *)summary error:(NSError *)error;
-(void)ping:(GamePing *)pinger didTimeoutWithSummary:(GamePingSummary *)summary;
-(void)ping:(GamePing *)pinger didReceiveReplyWithSummary:(GamePingSummary *)summary;
-(void)ping:(GamePing *)pinger didReceiveUnexpectedReplyWithSummary:(GamePingSummary *)summary;

@end

NS_ASSUME_NONNULL_END
